Subject: RE: WG Last Call Comment for 3280bis

From: "Santosh Chokhani" <[email-masked]>
Date: Fri, 8 Dec 2006 08:13:34 -0800

Carlos,

If you verified a certificate using current CRL, that is like verifying as of this time and not as of a time in the past.

Logical definition of a time of interest is to say what the PKI artifacts were at that time and what answer we would have gotten.

The proposed solution also keeps the business model for hold out in the first place.

________________________________

From: [email-masked] [mailto:[email-masked]] On Behalf Of Carlos González-Cadenas
Sent: Friday, December 08, 2006 11:06 AM
To: Santosh Chokhani
Cc: Stefan Santesson; Stephen Kent; pkix
Subject: Re: WG Last Call Comment for 3280bis

Santosh, Stefan,

I agree with Stefan in both proposals, seeing that the second is of great value, as it clarifies how to proceed for RPs in an area that is certainly difficult and open to interpretation.

I disagree with Santosh in this afirmation: 

>>I would think that Section 6 will give the answer you expect for current
>>time.  In terms of a time in the past, specifically for a time during
>>the hold period, I would think that the user should get CRL applicable 
>>at that time and reject the certificate.

I don't see any reason for not being able to validate in the past a certificate that is within its validity period in the instant of validation, using the latest CRL issued by the CA (no need in this case for archived CRLs). Using Stefan's proposal, if that certificate was removed from hold to valid in the past,  the validation will be successful (no entry in the CRL regarding this cert). 

Note that even when the certificate is expired and CRL archival is needed to validate the certificate, it's not necessary to pick the CRL that included the certificate on-hold. One can get the latest CRL issued before certificate expiration (this makes sense, as it's the most updated one). 

For me this behaviour makes sense, the certificate will be only rejected when it's on-hold and you're validating this certificate in this hold period. When the certificate is removed from hold to valid, no need to consider this certificate revoked in any time in the future (including validations performed after the hold period). 

Best regards,

Carlos

On 12/8/06, Santosh Chokhani <[email-masked]> wrote: 

Stefan,

I agree with your concern, but not your solution.

Section 6.1 of thee 3280 Biz states: 

"The algorithm presented in this section validates the certificate with
respect to the current date and time.  A conforming implementation MAY
also support validation with respect to some point in the past.  Note 
that mechanisms are not available for validating a certificate with
respect to a time outside the certificate validity period."

I would think that Section 6 will give the answer you expect for current
time.  In terms of a time in the past, specifically for a time during
the hold period, I would think that the user should get CRL applicable
at that time and reject the certificate.

BTW, is there a reason you do not answer about CRL Issuer question?  Do 
you compliant Issuers to have option of asserting hold instruction?

-----Original Message-----
From: Stefan Santesson [mailto:[email-masked]]
Sent: Friday, December 08, 2006 7:35 AM 
To: Santosh Chokhani; Stephen Kent
Cc: pkix
Subject: RE: WG Last Call Comment for 3280bis

Santosh.

What I mean by the second remark, is not what it means from a business
model perspective. I was aiming of what it means technically from a path 
validation perspective. The tricky part is that this is mostly matter
for historical validation, and historical validation is out of scope for
RFC 3280, and should be.

However, the important point is if a certificate is validated in the 
present, and it is not revoked, it doesn't matter if that certificate
has been on hold in the past, even if the signature validated was signed
during a time window when the certificate was on hold.

This seems to be a source of confusion and thus a clarification might be 
useful.

Stefan Santesson
Senior Program Manager
Windows Security, Standards

> -----Original Message-----
> From: Santosh Chokhani [mailto:[email-masked] ]
> Sent: den 8 december 2006 12:47
> To: Stefan Santesson; Stephen Kent
> Cc: pkix
> Subject: RE: WG Last Call Comment for 3280bis
>
> Stefan,
>
> See below.
>
> -----Original Message-----
> From: Stefan Santesson [mailto:[email-masked]]
> Sent: Friday, December 08, 2006 6:25 AM
> To: Santosh Chokhani; Stephen Kent 
> Cc: pkix
> Subject: RE: WG Last Call Comment for 3280bis
>
> To be picky;
> We need to be careful not to say that anyone must reject a
certificate.
> This is still a decision of the RP. There is a difference between the 
> decision to rely on something for a business reason and to accept the
> certificate as valid.
>
> What we should say is that: A certificate on hold MUST be treated as
> revoked and MUST fail path validation regardless of any present hold 
> instruction code.
> [Santosh Chokhani] Agree.
>
> What we also might want to say is: A certificate that has been cleared
> from on hold status to a non revoked status SHOULD be treated as if it 
> has never been revoked or on hold. I.e. that the certificate once
> cleared is valid for its full validity period.
> [Santosh Chokhani] I am not sure on this one.  It depends on the
> business model and RP. 
>
> Also, what about compliant CRL Issuers?  Should they use hold
> instruction extension.  Backward compatibility notwithstanding, I
think
> not.
>
>
> Stefan Santesson
> Senior Program Manager 
> Windows Security, Standards
>
> > -----Original Message-----
> > From: [email-masked] [mailto:owner-ietf- 
> > [email-masked]] On Behalf Of Santosh Chokhani
> > Sent: den 7 december 2006 01:19
> > To: Stephen Kent
> > Cc: pkix
> > Subject: RE: WG Last Call Comment for 3280bis 
> >
> >
> > Steve,
> >
> > How about the following:
> >
> > Compliant producers (i.e., CAs and CRL Issuers) shall not use hold
> > instruction.
> > 
> > Compliant consumer (i.e., relying parties) shall reject the
> certificate
> > regardless of the hold instruction.  Compliant consumers may take
> > additional actions as suggested by the hold instruction as long as 
> > those
> > actions are consistent with the rejection of the certificate.
> >
> > -----Original Message-----
> > From: Stephen Kent [mailto:[email-masked] ]
> > Sent: Wednesday, December 06, 2006 6:34 PM
> > To: Santosh Chokhani
> > Cc: pkix
> > Subject: RE: WG Last Call Comment for 3280bis
> >
> > At 2:19 PM -0800 12/6/06, Santosh Chokhani wrote: 
> > >Steve,
> > >
> > >My apologies for the interruption.
> > >
> > >We generally use hold and suspension as the same.
> > >
> > >A practical and simple solution for 3280 Bis is to recommend that 
> > >regardless of the hold instruction, the certificate that is on hold
> as
> > >of the time of interest shall be rejected.
> > >
> >
> > Yes, that is the simplest thing to do. The only other question is 
> > what we say about hold instructions, short of banning them, given
> > that we require only that a client treat a cert on hold just like
any
> > other cert on a CRL.
> > Steve

---

From: "Carlos González-Cadenas" <[email-masked]>
Date: Fri, 8 Dec 2006 17:37:03 +0100

Santosh,

I don't agree in your affirmation:

>>If you verified a certificate using current CRL, that is like verifying as
of this time and not >>as of a time in the past.

Using up-to-date CRL information doesn't imply verifying the certificate
status at this time. In fact, the CRL entries contain (past) information
about when the revocation of the certificate was produced (so you can use
this information to compare with the instant of time you want to validate
the certificate in).

Being the nature of CRL like an "historical accumulative database of
revocation events",  for sure you want the most-updated applicable CRL (when
saying "applicable" I mean that not all the CRLs issued by a CA contain
information for that certificate, potentially only the ones issued before
the certificate expiration time).

The CA is only allowed to remove revocation entries from the "historical
accumulative database" (CRL) in the on-hold case, when the certificate is
finally determined valid: so, no revocation event, I don't see why would one
want to reject the certificate after the on-hold period, when the CA
considers there's no revoked certificate (it only makes sense within the
on-hold period as a cautionary measure).

Best regards,

Carlos

On 12/8/06, Santosh Chokhani <[email-masked]> wrote:
>
>  Carlos,
>
>
>
> If you verified a certificate using current CRL, that is like verifying as
> of this time and not as of a time in the past.
>
>
>
> Logical definition of a time of interest is to say what the PKI artifacts
> were at that time and what answer we would have gotten.
>
>
>
>  ------------------------------
>
> *From:* [email-masked] [mailto:
> [email-masked]] *On Behalf Of *Carlos González-Cadenas
> *Sent:* Friday, December 08, 2006 11:06 AM
> *To:* Santosh Chokhani
> *Cc:* Stefan Santesson; Stephen Kent; pkix
> *Subject:* Re: WG Last Call Comment for 3280bis
>
>
>
> Santosh, Stefan,
>
> I agree with Stefan in both proposals, seeing that the second is of great
> value, as it clarifies how to proceed for RPs in an area that is certainly
> difficult and open to interpretation.
>
> I don't see any reason for not being able to validate in the past a
> certificate that is within its validity period in the instant of validation,
> using the latest CRL issued by the CA (no need in this case for archived
> CRLs). Using Stefan's proposal, if that certificate was removed from hold to
> valid in the past,  the validation will be successful (no entry in the CRL
> regarding this cert).
>
> Note that even when the certificate is expired and CRL archival is needed
> to validate the certificate, it's not necessary to pick the CRL that
> included the certificate on-hold. One can get the latest CRL issued before
> certificate expiration (this makes sense, as it's the most updated one).
>
> For me this behaviour makes sense, the certificate will be only rejected
> when it's on-hold and you're validating this certificate in this hold
> period. When the certificate is removed from hold to valid, no need to
> consider this certificate revoked in any time in the future (including
> validations performed after the hold period).
>
> Best regards,
>
> Carlos
>
> On 12/8/06, *Santosh Chokhani* <[email-masked]> wrote:
>
>
> Stefan,
>

---

From: "Kemp, David P." <[email-masked]>
Date: Fri, 8 Dec 2006 14:17:37 -0500

Carlos,

Historical validation, whether or not it's out of scope, means getting the same answer today ("as of some time in the past") that you would have gotten had you actually performed the validation at that time in the past.

What Stefan (correctly) said was that if a document is signed during an on-hold period and validated today, it will pass validation if the signing certificate is removed from hold.

What Santosh (correctly) said was that if you use a current CRL, you are validating as of the present time a previously-generated signature.

What you said is not a matter subject to difference of opinion, it is simply factually incorrect, which I'm sure Stefan would acknowledge:

Using up-to-date CRL information doesn't imply verifying the certificate status at this time. In fact, the CRL entries contain (past) information about when the revocation of the certificate was produced (so you can use this information to compare with the instant of time you want to validate the certificate in).

If you take a photograph of your screen in November (during hold) showing a failure, and take a photograph of the same screen in December (after remove-from-hold) showing success, and take a third photograph in December of a screen saying "give me the status as of November", you will be able to tell whether the application in the third picture is attempting to re-write history.

The fact that there is any confusion about this at all is what leads computer-knowledgeable people to distrust voting without a paper trail.

Dave

  _____  

From: [email-masked] [mailto:[email-masked]] On Behalf Of Carlos González-Cadenas
Sent: Friday, December 08, 2006 11:37 AM
To: Chokhani, Santosh
Cc: Stefan Santesson; Stephen Kent; pkix
Subject: Re: WG Last Call Comment for 3280bis

Santosh,

I don't agree in your affirmation:

>>If you verified a certificate using current CRL, that is like verifying as of this time and not >>as of a time in the past.

Using up-to-date CRL information doesn't imply verifying the certificate status at this time. In fact, the CRL entries contain (past) information about when the revocation of the certificate was produced (so you can use this information to compare with the instant of time you want to validate the certificate in). 

Being the nature of CRL like an "historical accumulative database of revocation events",  for sure you want the most-updated applicable CRL (when saying "applicable" I mean that not all the CRLs issued by a CA contain information for that certificate, potentially only the ones issued before the certificate expiration time). 

The CA is only allowed to remove revocation entries from the "historical accumulative database" (CRL) in the on-hold case, when the certificate is finally determined valid: so, no revocation event, I don't see why would one want to reject the certificate after the on-hold period, when the CA considers there's no revoked certificate (it only makes sense within the on-hold period as a cautionary measure). 

Best regards,

Carlos

Carlos,

  _____  

From: [email-masked] [mailto: <mailto:[email-masked]>  [email-masked]] On Behalf Of Carlos González-Cadenas
Sent: Friday, December 08, 2006 11:06 AM
To: Santosh Chokhani
Cc: Stefan Santesson; Stephen Kent; pkix
Subject: Re: WG Last Call Comment for 3280bis

Santosh, Stefan,

Best regards,

Carlos

On 12/8/06, Santosh Chokhani < [email-masked] <mailto:[email-masked]> > wrote: 

Stefan,

-----Original Message-----
From: Stefan Santesson [mailto:[email-masked]]
Sent: Friday, December 08, 2006 7:35 AM 
To: Santosh Chokhani; Stephen Kent
Cc: pkix
Subject: RE: WG Last Call Comment for 3280bis

Santosh.

Stefan Santesson
Senior Program Manager

> From: Santosh Chokhani [mailto:[email-masked]  <mailto:[email-masked]> ]
certificate.
think
> > From: [email-masked] [mailto:owner-ietf-  <mailto:owner-ietf-> 
> > From: Stephen Kent [mailto:[email-masked]  <mailto:[email-masked]> ]
any